<template>
  <div>
    <div class="row mt-5">
      <div class="col-md-12">
        <SavingCampaignStats
          v-if="this.showStats"
          v-bind:campaignId="statsCampaignId"
          v-bind:campaignName="statsCampaignName"
        ></SavingCampaignStats>

          <SavingCampaignWizard></SavingCampaignWizard>
        <div class="card">
          <div class="card-header">
            <h3 class="card-title">Saving campaigns</h3>
                         <div class="card-tools">
              <button class="btn btn-success add-new-btn" @click="create()">
                Add New &nbsp;
                <i class="fas fa-plus"></i>
              </button>
            </div>
          </div>
          <div class="saving-campaign-box">
            <div class="card-body table-responsive p-0">
              <table class="table table-hover table-striped">
                <tbody>
                  <tr>
                    <th>Name</th>
                    <th>Month</th>
                    <th>Planned income, €</th>
                    <th>Status</th>
                    <th>Actions</th>
                    <th>Show statistics</th>
                  </tr>
                  <tr v-for="campaign in campaigns.data" :key="campaign.id">
                    <td>{{ campaign.name }}</td>
                    <td>{{ moment(campaign.date).format("YYYY-MM") }}</td>
                    <td>{{ campaign.income }} €</td>
                    <td v-if="campaign.active == '1'" class="bg-main-color">Active</td>
                    <td v-else-if="campaign.active == '2'" class="bg-soft-blue">Upcoming</td>
                    <td v-else class="bg-soft-red">Expired</td>
                    <td>
                      <a href="#" @click="edit(campaign.id)">
                        <i class="fa fa-edit blue"></i>
                      </a>
                      <a href="#" @click="deleteCampaign(campaign.id)">
                        <i class="fa fa-trash red"></i>
                      </a>
                    </td>
                    <td>
                      <button
                        v-if="campaign.active == 0 || campaign.active == 1"
                        class="btn btn-success"
                        @click="afterCampaignSelect(campaign.id,campaign.name)"
                      >
                        Show stats
                        <i class="fas fa-chart-bar fa-fw"></i>
                      </button>

                      <p v-else>-</p>
                    </td>
                  </tr>
                </tbody>
              </table>
            </div>
          </div>
          <div class="card-footer">
            <pagination :data="campaigns" @pagination-change-page="getCampaigns"></pagination>
          </div>
          <!-- /.card-body -->
        </div>
      </div>
    </div>

    <div v-if="!$gate.isAdminOrUser()">
      <not-found></not-found>
    </div>
  </div>
</template>

<script>
import moment from "moment";
import SavingCampaignStats from "./SavingCampaignStats";
import SavingCampaignWizard from "./SavingCampaignWizard";
import VueMonthlyPicker from "vue-monthly-picker";
export default {
  components: {
    SavingCampaignStats,
    VueMonthlyPicker,
    SavingCampaignWizard,
    moment
  },
  data() {
    return {
      statsCampaignId: "",
      statsCampaignName: "",
      predictedBalance: "",
      campaigns: {},
      totalStats: "",
      moment: moment,
      editmode: false,
      categories: {},
      monthBeforePerc: {},
      showStats: false,
      selectedMonth: moment(new Date()).format("YYYY-MM")
  }},

  methods: {

    create() { 
      Fire.$emit(
          "CreateSavingCampaign"
        );
    },
    edit(id) { 

          Fire.$emit(
          "EditSavingCampaign",
          id
        );
    },
    loadSavingCampaings() {
           this.$Progress.start();
      axios
        .get("api/saving-campaign")
        .then(response => {
          this.campaigns = response.data;
          if (this.campaigns.data.length > 0) {
            this.showStats = true;
          }
               this.$Progress.finish();
        })
        .catch(error => {
          swal("Failed!", "There was something wrong.", "warning");
          this.$Progress.fail();
          console.log(error);
        });
    },

    getCampaigns(page = 1) {
      axios
        .get("api/saving-campaign", {
          params: {
            page: page
          }
        })
        .then(response => {
          this.campaigns = response.data;
        })
        .catch(error => {
          swal("Failed!", "There was something wrong.", "warning");
          this.$Progress.fail();
          console.log(error);
        });
    },

    afterCampaignSelect(id, name) {
      this.statsCampaignId = id;
      this.statsCampaignName = name;
    },

    deleteCampaign(id) {
      swal({
        title: "Are you sure?",
        text: "You won't be able to revert this!",
        type: "warning",
        showCancelButton: true,
        confirmButtonColor: "#3085d6",
        cancelButtonColor: "#d33",
        confirmButtonText: "Yes, delete it!"
      }).then(result => {
        if (result.value) {
          axios.delete("api/saving-campaign/" + id)
            .then(() => {
              swal(
                "Deleted!",
                "Your saving campaign has been deleted.",
                "success"
              );
              Fire.$emit("loadCampaignsAndCategories");
            })
            .catch(error => {
              swal("Failed!", "There was something wrong.", "warning");
              this.$Progress.fail();
              console.log(error);
            });
        }
      });
    }
  },
  created() {
    this.statsCampaignId = "null";

    this.loadSavingCampaings();
 //   this.loadCategories(); todo

    Fire.$on("loadCampaignsAndCategories", () => {
      this.loadSavingCampaings();
     // this.loadCategories(); todo
    });

    Fire.$on("hideStats", () => {
      this.showStats = false;
    });
  }
};
</script>